/// <reference types="node" />
import Stream from 'stream';
import { MTurkParaphraseExample } from './validator';
export interface MTurkValidationExample {
    synthetic_id: string;
    target_code: string;
    synthetic: string;
    paraphrases: Array<{
        id: string;
        paraphrase: string;
    }>;
}
interface ValidationHITCreatorOptions {
    debug: boolean;
    targetSize: number;
    sentencesPerTask: number;
    rng: () => number;
}
export default class ValidationHITCreator extends Stream.Transform {
    private _batch;
    private _i;
    private _buffer;
    private _debug;
    private _targetSize;
    private _sentencesPerTask;
    private _rng;
    constructor(batch: MTurkParaphraseExample[], options: ValidationHITCreatorOptions);
    _transform(row: MTurkValidationExample, encoding: BufferEncoding, callback: () => void): void;
    _flush(callback: () => void): void;
}
export {};
