import AppExecutor from '../engine/apps/app_executor';
import type { UserInput as Command } from './user-input';
declare class QueueItem {
}
declare type JSError = Error;
declare namespace QueueItem {
    class UserInput extends QueueItem {
        command: Command;
        constructor(command: Command);
        toString(): string;
    }
    class Notification extends QueueItem {
        app: AppExecutor;
        outputType: string;
        outputValue: Record<string, unknown>;
        constructor(app: AppExecutor, outputType: string, outputValue: Record<string, unknown>);
        toString(): string;
    }
    class Error extends QueueItem {
        app: AppExecutor;
        error: JSError;
        constructor(app: AppExecutor, error: JSError);
        toString(): string;
    }
}
export default QueueItem;
