import * as ThingTalk from 'thingtalk';
import type DialogueLoop from './dialogue-loop';
export declare function formatError(dlg: DialogueLoop, error: Error | string): string;
export declare function presentExample(dlg: DialogueLoop, utterance: string): string;
export declare function loadOneExample(ex: ThingTalk.Ast.Example): {
    utterance: string;
    type: string;
    monitorable: boolean;
    target: {
        example_id: number;
        code: [string[], ThingTalk.Syntax.EntityMap];
        entities: {};
        slotTypes: Record<string, string>;
        slots: string[];
    };
} | null;
export declare function loadExamples(dataset: string, schemaRetriever: ThingTalk.SchemaRetriever, maxCount: number): Promise<{
    utterance: string;
    type: string;
    monitorable: boolean;
    target: {
        example_id: number;
        code: [string[], ThingTalk.Syntax.EntityMap];
        entities: {};
        slotTypes: Record<string, string>;
        slots: string[];
    };
}[]>;
export declare function presentExampleList(dlg: DialogueLoop, examples: Array<{
    utterance: string;
    target: string;
}>): void;
