import type Engine from '../../engine';
import { FormattedObject } from './formatter';
interface TwilioConfig {
    accountSid: string;
    authToken: string;
    from: string;
    fromByLocale?: Record<string, string>;
}
export default class TwilioNotificationBackend {
    private _platform;
    private _client;
    private _from;
    name: string;
    uniqueId: string;
    constructor(engine: Engine, config: TwilioConfig);
    get requiredSettings(): {
        to: string;
    };
    notify(data: {
        appId: string;
        icon: string | null;
        raw: Record<string, unknown>;
        type: string;
        formatted: FormattedObject[];
    }, config?: Record<string, string>): Promise<void>;
    notifyError(data: {
        appId: string;
        icon: string | null;
        error: Error;
    }): Promise<void>;
}
export {};
