"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const linked_list_1 = __importDefault(require("./linked_list"));
class RateLimiter {
    constructor(burst, interval) {
        this._queue = new linked_list_1.default();
        this._burst = burst;
        this._interval = interval;
    }
    hit() {
        let now = Date.now();
        while (this._queue.size >= this._burst) {
            let oldest = this._queue.peek();
            if (now - oldest > this._interval)
                this._queue.pop();
            else
                return false;
        }
        this._queue.unshift(now);
        return true;
    }
}
exports.default = RateLimiter;
//# sourceMappingURL=rate_limiter.js.map