import * as Tp from 'thingpedia';
import { EntityMap } from '../utils/entity-utils';
import { ParseOptions, PredictionResult, GenerationResult } from './types';
export default class RemoteParserClient {
    private _locale;
    private _baseUrl;
    private _platform;
    private _tpClient;
    private _exactmatcher;
    constructor(baseUrl: string, locale: string, platform?: Tp.BasePlatform, tpClient?: Tp.BaseClient);
    start(): Promise<void>;
    stop(): Promise<void>;
    onlineLearn(utterance: string, code: string[], store?: string): Promise<string | undefined>;
    sendUtterance(utterance: string, contextCode: string[] | undefined, contextEntities: EntityMap | undefined, options?: ParseOptions): Promise<PredictionResult>;
    generateUtterance(contextCode: string[], contextEntities: EntityMap, targetAct: string[]): Promise<GenerationResult[]>;
}
