import { EntityMap } from '../utils/entity-utils';
export interface ExactMatcher {
    get(tokens: string[]): string[][] | null;
}
export interface ParseOptions {
    thingtalk_version?: string;
    store?: string;
    answer?: string;
    expect?: string;
    choices?: string[];
    tokenized?: boolean;
    skip_typechecking?: boolean;
    example_id?: string;
}
export interface PredictionCandidate {
    code: string[];
    score: number | 'Infinity';
}
export interface PredictionResult {
    result: 'ok';
    tokens: string[];
    entities: EntityMap;
    candidates: PredictionCandidate[];
    intent: {
        command: number;
        other: number;
        ignore: number;
    };
}
export interface GenerationResult {
    answer: string;
    score: number;
}
