export default abstract class List<T> {
    static Nil: List<never>;
    static concat<T>(...lists: Array<T | List<T>>): List<T>;
    static join<T>(l1: List<T>, l2: List<T>): List<T>;
    static singleton<T>(el: T): List<T>;
    static append<T>(list: List<T>, el: T): List<T>;
    abstract traverse(cb: (x: T) => void): void;
    abstract getFirst(): T;
}
