import { BaseTrainingJob, TrainingJobOptions } from './base_training_job';
export interface GenieNLPConfig {
    task_name: 'almond' | 'almond_dialogue_nlu';
    train_iterations: number;
    save_every: number;
    log_every: number;
    val_every: number;
    [key: string]: unknown;
}
export default class GenieNLPTrainingJob extends BaseTrainingJob {
    private _config;
    constructor(options: TrainingJobOptions & {
        config: GenieNLPConfig;
    });
    get config(): GenieNLPConfig;
    _train(): Promise<void>;
    _findBestModel(): Promise<void>;
    train(): Promise<void>;
}
