import { Type } from 'thingtalk';
import * as I18n from '../i18n';
import { makeDummyEntity, makeDummyEntities, renumberEntities } from './entity-utils';
declare function clean(name: string): string;
export declare function cleanKind(kind: string): string;
declare function split(pattern: string, regexp: RegExp | string): Generator<string | string[], void>;
declare function splitParams(utterance: string): Array<string | string[]>;
declare function tokenizeExample(tokenizer: I18n.BaseTokenizer, utterance: string, id: number): string;
declare function sampleString(words: string[], langPack: I18n.LanguagePack, rng: () => number): string | null;
declare function isHumanEntity(type: Type | string): boolean;
export { splitParams, split, clean, tokenizeExample, sampleString, isHumanEntity, makeDummyEntity, makeDummyEntities, renumberEntities, };
