/**
 * Standard max-heap-based priority queue.
 *
 * Elements must be object and are sorted according to their `priority` property.
 * Ties are broken by insertion order.
 */
export default class PriorityQueue<T extends {
    priority: number;
}> {
    private _storage;
    constructor();
    get size(): number;
    private _getParent;
    private _getLeftChild;
    private _getRightChild;
    private _swap;
    push(element: T): void;
    peek(): T | undefined;
    pop(): T | undefined;
}
