export namespace BUILTIN_TYPEMAP {
    const Time: ThingTalk.Type;
    const Number: ThingTalk.Type;
    const Float: ThingTalk.Type;
    const Integer: ThingTalk.Type;
    const Text: ThingTalk.Type;
    const Boolean: ThingTalk.Type;
    const DateTime: ThingTalk.Type;
    const Date: ThingTalk.Type;
    const DataType: ThingTalk.Type;
    const URL: import("thingtalk/dist/type").EntityType;
    const ImageObject: import("thingtalk/dist/type").EntityType;
    const Barcode: import("thingtalk/dist/type").EntityType;
    const Mass: import("thingtalk/dist/type").MeasureType;
    const Energy: import("thingtalk/dist/type").MeasureType;
    const Distance: import("thingtalk/dist/type").MeasureType;
    const Duration: import("thingtalk/dist/type").MeasureType;
    const GeoCoordinates: ThingTalk.Type;
    const MonetaryAmount: ThingTalk.Type;
    const QuantitativeValue: ThingTalk.Type;
}
export const BLACKLISTED_TYPES: Set<string>;
export const BLACKLISTED_PROPERTIES: Set<string>;
export namespace BLACKLISTED_PROPERTIES_BY_DOMAIN {
    const movies: string[];
}
export namespace WHITELISTED_PROPERTIES_BY_DOMAIN {
    const restaurants: string[];
    const hotels: string[];
    const people: string[];
    const linkedin: string[];
    const books: string[];
    const music: string[];
}
export const STRUCTURED_HIERARCHIES: string[];
export const NON_STRUCT_TYPES: Set<never>;
export namespace PROPERTY_CANONICAL_OVERRIDE {
    namespace url {
        const base: string[];
    }
    namespace name {
        const base_1: string[];
        export { base_1 as base };
        export const passive_verb: string[];
    }
    namespace description {
        const base_2: string[];
        export { base_2 as base };
    }
    namespace image {
        const base_3: string[];
        export { base_3 as base };
    }
    namespace geo {
        const base_4: string[];
        export { base_4 as base };
        export const preposition: string[];
    }
    namespace postalCode {
        const base_5: string[];
        export { base_5 as base };
        const preposition_1: string[];
        export { preposition_1 as preposition };
    }
    namespace addressCountry {
        const preposition_2: string[];
        export { preposition_2 as preposition };
        const base_6: string[];
        export { base_6 as base };
    }
    namespace addressRegion {
        const preposition_3: string[];
        export { preposition_3 as preposition };
        const base_7: string[];
        export { base_7 as base };
    }
}
export namespace PROPERTY_NAME_OVERRIDE_BY_DOMAIN {
    const restaurants_1: {
        'starRating.ratingValue': string;
    };
    export { restaurants_1 as restaurants };
    const hotels_1: {
        'starRating.ratingValue': string;
    };
    export { hotels_1 as hotels };
    const people_1: {
        'address.addressLocality': string;
    };
    export { people_1 as people };
}
export namespace MANUAL_PROPERTY_CANONICAL_OVERRIDE {
    namespace datePublished {
        const passive_verb_1: string[];
        export { passive_verb_1 as passive_verb };
        const base_8: string[];
        export { base_8 as base };
        export const adjective_argmax: string[];
        export const adjective_argmin: string[];
        export const base_projection: string[];
        export const passive_verb_projection: string[];
    }
    namespace ratingValue {
        const passive_verb_2: string[];
        export { passive_verb_2 as passive_verb };
        const base_9: string[];
        export { base_9 as base };
        export const adjective: string[];
        const adjective_argmax_1: string[];
        export { adjective_argmax_1 as adjective_argmax };
        export const projection_pronoun: string[];
        const passive_verb_projection_1: string[];
        export { passive_verb_projection_1 as passive_verb_projection };
    }
    namespace reviewRating {
        const base_10: string[];
        export { base_10 as base };
    }
    namespace telephone {
        const base_11: string[];
        export { base_11 as base };
    }
    namespace servesCuisine {
        const adjective_1: string[];
        export { adjective_1 as adjective };
        export const verb: string[];
        export const property: string[];
        const base_12: string[];
        export { base_12 as base };
        const base_projection_1: string[];
        export { base_projection_1 as base_projection };
        export const verb_projection: string[];
    }
    namespace priceRange {
        const base_13: string[];
        export { base_13 as base };
        const adjective_2: string[];
        export { adjective_2 as adjective };
    }
    namespace openingHours {
        const verb_1: string[];
        export { verb_1 as verb };
        const verb_projection_1: string[];
        export { verb_projection_1 as verb_projection };
    }
    namespace acceptsReservation {
        const verb_true: string[];
    }
    namespace smokingAllowed {
        export const property_true: string[];
        export const property_false: string[];
        const verb_true_1: string[];
        export { verb_true_1 as verb_true };
    }
    namespace author {
        const base_14: string[];
        export { base_14 as base };
        const preposition_4: string[];
        export { preposition_4 as preposition };
        const passive_verb_3: string[];
        export { passive_verb_3 as passive_verb };
        const verb_2: string[];
        export { verb_2 as verb };
        const base_projection_2: string[];
        export { base_projection_2 as base_projection };
        export const reverse_verb_projection: string[];
        const passive_verb_projection_2: string[];
        export { passive_verb_projection_2 as passive_verb_projection };
    }
    namespace amenityFeature {
        const base_15: string[];
        export { base_15 as base };
        const verb_3: string[];
        export { verb_3 as verb };
        const base_projection_3: string[];
        export { base_projection_3 as base_projection };
        const verb_projection_2: string[];
        export { verb_projection_2 as verb_projection };
    }
    namespace checkinTime {
        const base_16: string[];
        export { base_16 as base };
    }
    namespace checkoutTime {
        const base_17: string[];
        export { base_17 as base };
    }
    namespace petsAllowed {
        const property_true_1: string[];
        export { property_true_1 as property_true };
        const property_false_1: string[];
        export { property_false_1 as property_false };
        const verb_true_2: string[];
        export { verb_true_2 as verb_true };
        export const adjective_true: string[];
    }
    namespace alumniOf {
        const base_18: string[];
        export { base_18 as base };
        export const reverse_property: string[];
        const verb_4: string[];
        export { verb_4 as verb };
        const passive_verb_4: string[];
        export { passive_verb_4 as passive_verb };
        const base_projection_4: string[];
        export { base_projection_4 as base_projection };
        const verb_projection_3: string[];
        export { verb_projection_3 as verb_projection };
        const passive_verb_projection_3: string[];
        export { passive_verb_projection_3 as passive_verb_projection };
    }
    namespace award {
        const base_19: string[];
        export { base_19 as base };
        const reverse_property_1: string[];
        export { reverse_property_1 as reverse_property };
        const verb_5: string[];
        export { verb_5 as verb };
        const base_projection_5: string[];
        export { base_projection_5 as base_projection };
        const verb_projection_4: string[];
        export { verb_projection_4 as verb_projection };
        const passive_verb_5: string[];
        export { passive_verb_5 as passive_verb };
    }
    namespace worksFor {
        const base_20: string[];
        export { base_20 as base };
        const reverse_property_2: string[];
        export { reverse_property_2 as reverse_property };
        const verb_6: string[];
        export { verb_6 as verb };
        const passive_verb_6: string[];
        export { passive_verb_6 as passive_verb };
        const base_projection_6: string[];
        export { base_projection_6 as base_projection };
        const verb_projection_5: string[];
        export { verb_projection_5 as verb_projection };
    }
    namespace jobTitle {
        const base_21: string[];
        export { base_21 as base };
        const reverse_property_3: string[];
        export { reverse_property_3 as reverse_property };
    }
    namespace knowsLanguage {
        const base_22: string[];
        export { base_22 as base };
        const verb_7: string[];
        export { verb_7 as verb };
        const base_projection_7: string[];
        export { base_projection_7 as base_projection };
        const verb_projection_6: string[];
        export { verb_projection_6 as verb_projection };
        const adjective_3: string[];
        export { adjective_3 as adjective };
    }
    namespace addressLocality {
        const base_23: string[];
        export { base_23 as base };
        const preposition_5: string[];
        export { preposition_5 as preposition };
    }
    namespace publisher {
        const base_24: string[];
        export { base_24 as base };
        const preposition_6: string[];
        export { preposition_6 as preposition };
        const passive_verb_7: string[];
        export { passive_verb_7 as passive_verb };
    }
    namespace prepTime {
        const verb_8: string[];
        export { verb_8 as verb };
        const base_25: string[];
        export { base_25 as base };
    }
    namespace cookTime {
        const verb_9: string[];
        export { verb_9 as verb };
        const base_26: string[];
        export { base_26 as base };
    }
    namespace totalTime {
        const verb_10: string[];
        export { verb_10 as verb };
        const base_27: string[];
        export { base_27 as base };
    }
    namespace recipeYield {
        const verb_11: string[];
        export { verb_11 as verb };
        const passive_verb_8: string[];
        export { passive_verb_8 as passive_verb };
        const base_28: string[];
        export { base_28 as base };
    }
    namespace recipeCategory {
        const adjective_4: string[];
        export { adjective_4 as adjective };
        const base_29: string[];
        export { base_29 as base };
    }
    namespace recipeIngredient {
        const adjective_5: string[];
        export { adjective_5 as adjective };
        const verb_12: string[];
        export { verb_12 as verb };
        const passive_verb_9: string[];
        export { passive_verb_9 as passive_verb };
        const base_30: string[];
        export { base_30 as base };
    }
    namespace recipeInstructions {
        const base_31: string[];
        export { base_31 as base };
    }
    namespace recipeCuisines {
        const adjective_6: string[];
        export { adjective_6 as adjective };
        const verb_13: string[];
        export { verb_13 as verb };
        const base_32: string[];
        export { base_32 as base };
    }
    namespace reviewBody {
        const base_33: string[];
        export { base_33 as base };
    }
    namespace saturatedFatContent {
        const base_34: string[];
        export { base_34 as base };
    }
    namespace mpn {
        const base_35: string[];
        export { base_35 as base };
    }
    namespace color {
        const base_36: string[];
        export { base_36 as base };
        const adjective_7: string[];
        export { adjective_7 as adjective };
        const preposition_7: string[];
        export { preposition_7 as preposition };
    }
    namespace model {
        const base_37: string[];
        export { base_37 as base };
        export const implicit_identity: boolean;
    }
    namespace brand {
        const base_38: string[];
        export { base_38 as base };
        const adjective_8: string[];
        export { adjective_8 as adjective };
        const preposition_8: string[];
        export { preposition_8 as preposition };
        const passive_verb_10: string[];
        export { passive_verb_10 as passive_verb };
    }
    namespace inLanguage {
        const base_39: string[];
        export { base_39 as base };
        const adjective_9: string[];
        export { adjective_9 as adjective };
        const preposition_9: string[];
        export { preposition_9 as preposition };
        const passive_verb_11: string[];
        export { passive_verb_11 as passive_verb };
        const reverse_property_4: string[];
        export { reverse_property_4 as reverse_property };
        const base_projection_8: string[];
        export { base_projection_8 as base_projection };
        export const preposition_projection: string[];
        const passive_verb_projection_4: string[];
        export { passive_verb_projection_4 as passive_verb_projection };
    }
    namespace bookEdition {
        const base_40: string[];
        export { base_40 as base };
        const reverse_property_5: string[];
        export { reverse_property_5 as reverse_property };
    }
    namespace bookFormat {
        const base_41: string[];
        export { base_41 as base };
        const preposition_10: string[];
        export { preposition_10 as preposition };
    }
    namespace numberOfPages {
        const base_42: string[];
        export { base_42 as base };
        const property_1: string[];
        export { property_1 as property };
        const adjective_argmax_2: string[];
        export { adjective_argmax_2 as adjective_argmax };
        const adjective_argmin_1: string[];
        export { adjective_argmin_1 as adjective_argmin };
    }
    namespace abridged {
        const adjective_true_1: string[];
        export { adjective_true_1 as adjective_true };
    }
    namespace contentRating {
        const base_43: string[];
        export { base_43 as base };
        const adjective_10: string[];
        export { adjective_10 as adjective };
        const passive_verb_12: string[];
        export { passive_verb_12 as passive_verb };
    }
    namespace genre {
        const base_44: string[];
        export { base_44 as base };
        const adjective_11: string[];
        export { adjective_11 as adjective };
    }
    namespace creator {
        const base_45: string[];
        export { base_45 as base };
        const passive_verb_13: string[];
        export { passive_verb_13 as passive_verb };
        const verb_14: string[];
        export { verb_14 as verb };
        const base_projection_9: string[];
        export { base_projection_9 as base_projection };
        const reverse_verb_projection_1: string[];
        export { reverse_verb_projection_1 as reverse_verb_projection };
        const passive_verb_projection_5: string[];
        export { passive_verb_projection_5 as passive_verb_projection };
    }
    namespace duration {
        const base_46: string[];
        export { base_46 as base };
        const adjective_12: string[];
        export { adjective_12 as adjective };
        const adjective_argmax_3: string[];
        export { adjective_argmax_3 as adjective_argmax };
        const adjective_argmin_2: string[];
        export { adjective_argmin_2 as adjective_argmin };
    }
    namespace actor {
        const base_47: string[];
        export { base_47 as base };
        const property_2: string[];
        export { property_2 as property };
        const passive_verb_14: string[];
        export { passive_verb_14 as passive_verb };
        const verb_15: string[];
        export { verb_15 as verb };
        const base_projection_10: string[];
        export { base_projection_10 as base_projection };
        const verb_projection_7: string[];
        export { verb_projection_7 as verb_projection };
        const reverse_verb_projection_2: string[];
        export { reverse_verb_projection_2 as reverse_verb_projection };
        const preposition_projection_1: string[];
        export { preposition_projection_1 as preposition_projection };
    }
    namespace director {
        const base_48: string[];
        export { base_48 as base };
        const passive_verb_15: string[];
        export { passive_verb_15 as passive_verb };
        const verb_16: string[];
        export { verb_16 as verb };
        const reverse_verb_projection_3: string[];
        export { reverse_verb_projection_3 as reverse_verb_projection };
    }
    namespace inAlbum {
        const base_49: string[];
        export { base_49 as base };
        const preposition_11: string[];
        export { preposition_11 as preposition };
        const passive_verb_16: string[];
        export { passive_verb_16 as passive_verb };
        const verb_17: string[];
        export { verb_17 as verb };
        const base_projection_11: string[];
        export { base_projection_11 as base_projection };
        const verb_projection_8: string[];
        export { verb_projection_8 as verb_projection };
        const reverse_verb_projection_4: string[];
        export { reverse_verb_projection_4 as reverse_verb_projection };
        const passive_verb_projection_6: string[];
        export { passive_verb_projection_6 as passive_verb_projection };
        const preposition_projection_2: string[];
        export { preposition_projection_2 as preposition_projection };
    }
    namespace byArtist {
        const base_50: string[];
        export { base_50 as base };
        const adjective_13: string[];
        export { adjective_13 as adjective };
        const preposition_12: string[];
        export { preposition_12 as preposition };
        const passive_verb_17: string[];
        export { passive_verb_17 as passive_verb };
        const verb_18: string[];
        export { verb_18 as verb };
        const base_projection_12: string[];
        export { base_projection_12 as base_projection };
        const passive_verb_projection_7: string[];
        export { passive_verb_projection_7 as passive_verb_projection };
        const reverse_verb_projection_5: string[];
        export { reverse_verb_projection_5 as reverse_verb_projection };
    }
    namespace numTracks {
        const base_51: string[];
        export { base_51 as base };
    }
}
export namespace MANUAL_PROPERTY_CANONICAL_OVERRIDE_BY_DOMAIN {
    const restaurants_2: {
        'starRating.ratingValue': {
            base: string[];
            adjective: string[];
            passive_verb: string[];
        };
    };
    export { restaurants_2 as restaurants };
    const hotels_2: {
        'aggregateRating.ratingValue': {
            passive_verb: string[];
            base: string[];
            adjective_argmax: string[];
            projection_pronoun: string[];
            passive_verb_projection: string[];
        };
        'starRating.ratingValue': {
            base: string[];
            property: string[];
            adjective: string[];
        };
    };
    export { hotels_2 as hotels };
}
export namespace TABLE_CANONICAL_OVERRIDE {
    const MusicRecording: string;
    const MusicAlbum: string;
}
export namespace MANUAL_TABLE_CANONICAL_OVERRIDE {
    export const Restaurant: string[];
    export const Hotel: string[];
    const MusicRecording_1: string[];
    export { MusicRecording_1 as MusicRecording };
    const MusicAlbum_1: string[];
    export { MusicAlbum_1 as MusicAlbum };
}
export namespace MANUAL_COUNTED_OBJECT_OVERRIDE {
    const numTracks_1: string[];
    export { numTracks_1 as numTracks };
}
export const PROPERTY_FORCE_NOT_ARRAY: Set<string>;
export const PROPERTY_FORCE_ARRAY: Set<string>;
export namespace PROPERTY_TYPE_OVERRIDE {
    const telephone_1: import("thingtalk/dist/type").EntityType;
    export { telephone_1 as telephone };
    export const email: import("thingtalk/dist/type").EntityType;
    export const faxNumber: import("thingtalk/dist/type").EntityType;
    const image_1: import("thingtalk/dist/type").EntityType;
    export { image_1 as image };
    export const logo: import("thingtalk/dist/type").EntityType;
    const checkinTime_1: ThingTalk.Type;
    export { checkinTime_1 as checkinTime };
    const checkoutTime_1: ThingTalk.Type;
    export { checkoutTime_1 as checkoutTime };
    export const price: ThingTalk.Type;
    export const weight: import("thingtalk/dist/type").MeasureType;
    export const depth: import("thingtalk/dist/type").MeasureType;
    const description_1: ThingTalk.Type;
    export { description_1 as description };
    const addressCountry_1: import("thingtalk/dist/type").EntityType;
    export { addressCountry_1 as addressCountry };
    const addressRegion_1: import("thingtalk/dist/type").EntityType;
    export { addressRegion_1 as addressRegion };
    export const video: import("thingtalk/dist/type").EntityType;
    const publisher_1: import("thingtalk/dist/type").EntityType;
    export { publisher_1 as publisher };
    const recipeYield_1: ThingTalk.Type;
    export { recipeYield_1 as recipeYield };
    const genre_1: import("thingtalk/dist/type").ArrayType;
    export { genre_1 as genre };
    const creator_1: import("thingtalk/dist/type").ArrayType;
    export { creator_1 as creator };
    const contentRating_1: import("thingtalk/dist/type").EnumType;
    export { contentRating_1 as contentRating };
    const byArtist_1: import("thingtalk/dist/type").EntityType;
    export { byArtist_1 as byArtist };
    const openingHours_1: ThingTalk.Type;
    export { openingHours_1 as openingHours };
    const priceRange_1: import("thingtalk/dist/type").EnumType;
    export { priceRange_1 as priceRange };
    export const workLocation: ThingTalk.Type;
    const inLanguage_1: import("thingtalk/dist/type").EntityType;
    export { inLanguage_1 as inLanguage };
    const knowsLanguage_1: import("thingtalk/dist/type").ArrayType;
    export { knowsLanguage_1 as knowsLanguage };
}
export const PROPERTIES_NO_FILTER: string[];
export const PROPERTIES_DROP_WITH_GEO: string[];
export const STRUCT_INCLUDE_THING_PROPERTIES: Set<string>;
export const STRING_FILE_OVERRIDES: {
    'org.schema.Restaurant:Restaurant_name': string;
    'org.schema.Person:Person_name': string;
    'org.schema.Person:Person_address_addressLocality': string;
    'org.schema.Person:Person_alumniOf': string;
    'org.schema.Person:Person_worksFor': string;
    'org.schema.Person:Person_jobTitle': string;
    'org.schema.Hotel:Hotel_name': string;
    'org.schema.Music:MusicRecording_byArtist': string;
    'org.schema.Music:MusicAlbum_byArtist': string;
    'org.schema.Music:MusicRecording_inAlbum': string;
    'org.schema.Music:MusicRecording_name': string;
    'org.schema.Music:CreativeWork_genre': string;
    'org.schema.Book:Book_name': string;
};
export namespace PROPERTY_RENAMES {
    export const checkInTime: string;
    export const checkOutTime: string;
    export const AggregateRating: string;
    export const awards: string;
    const reviewBody_1: string;
    export { reviewBody_1 as reviewBody };
}
export namespace ENUM_VALUE_NORMALIZE {
    const itemCondition: {
        New: string;
        BrandNew: string;
        NewWithBox: string;
        NewWithTags: string;
        NewWithoutTags: string;
        OpenBox: string;
        Used: string;
        ManufacturerRefurbished: string;
        SellerRefurbished: string;
        '--notSpecified': undefined;
    };
}
import * as ThingTalk from "thingtalk";
