import * as Tp from 'thingpedia';
export default class Platform extends Tp.BasePlatform {
    private _locale;
    private _gettext;
    private _timezone;
    private _filesDir;
    private _cacheDir;
    private _prefs;
    private _tpClient;
    constructor(homedir: string | undefined, locale: string, thingpediaUrl: string);
    get type(): string;
    get locale(): string;
    get timezone(): string;
    getPlatformDevice(): null;
    hasFeature(feature: string): boolean;
    hasCapability(cap: string): boolean;
    getCapability<T extends keyof Tp.Capabilities.CapabilityMap>(cap: T): Tp.Capabilities.CapabilityMap[T] | null;
    getSharedPreferences(): Tp.Helpers.FilePreferences;
    getWritableDir(): string;
    getTmpDir(): string;
    getCacheDir(): string;
    getSqliteDB(): string;
    getSqliteKey(): null;
    getGraphDB(): string;
    getDeveloperKey(): string | null;
    setDeveloperKey(key: string | undefined): string | undefined;
    getOrigin(): string;
    getCloudId(): string | null;
    getAuthToken(): string | undefined;
    setAuthToken(authToken: string): boolean;
}
