import * as Tp from 'thingpedia';
interface EntityRecord {
    type: string;
    value: string;
    canonical: string;
    name: string;
}
interface EntityLookupResult {
    meta: {
        name: string;
        is_well_known: boolean | number;
        has_ner_support: boolean | number;
    };
    data: EntityRecord[];
}
interface FileClientArgs {
    thingpedia: string;
    locale: string;
    entities?: string;
    dataset?: string;
    parameter_datasets: string;
}
/**
 * A subclass of {@link thingpedia}.FileClient that supports
 * looking up entities by value using the file parameter provider.
 */
export default class FileThingpediaClient extends Tp.FileClient {
    private _cachedEntities;
    private _provider;
    constructor(options: FileClientArgs);
    lookupEntity(entityType: string, searchTerm: string): Promise<EntityLookupResult>;
}
export {};
