import * as argparse from 'argparse';
import * as ThingTalk from 'thingtalk';
import LocalParserClient from '../lib/prediction/localparserclient';
import * as I18n from '../lib/i18n';
interface Backend {
    schemas: ThingTalk.SchemaRetriever;
    i18n: I18n.LanguagePack;
    tokenizer: I18n.BaseTokenizer;
    nlu: LocalParserClient;
    nlg?: LocalParserClient;
}
declare global {
    namespace Express {
        interface Application {
            backend: Backend;
            args: any;
        }
    }
}
export declare function initArgparse(subparsers: argparse.SubParser): void;
export declare function execute(args: any): Promise<void>;
export {};
