"use strict";
// -*- mode: typescript; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const thingtalk_1 = require("thingtalk");
const C = __importStar(require("../ast_manip"));
const load_thingpedia_1 = __importDefault(require("../load-thingpedia"));
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    $loader = new load_thingpedia_1.default($runtime, $ttUtils, $grammar, $locale, $options);
    await (await $runtime.import("../common.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await $loader.init();
    function special(specialType) {
        return new thingtalk_1.Ast.ControlCommand(null, new thingtalk_1.Ast.SpecialControlIntent(null, specialType));
    }
    await (await $runtime.import("./constants.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    $grammar.declareSymbol("bookkeeping");
    $grammar.addRule("bookkeeping", [], "debug", (() => special('debug')), undefined, {});
    $grammar.addRule("bookkeeping", [], "cancel", (() => special('nevermind')), undefined, {});
    $grammar.addRule("bookkeeping", [], "never mind", (() => special('nevermind')), undefined, {});
    $grammar.addRule("bookkeeping", [], "stop", (() => special('stop')), undefined, {});
    $grammar.addRule("bookkeeping", [], "shut up", (() => special('stop')), undefined, {});
    $grammar.addRule("bookkeeping", [], "shush", (() => special('stop')), undefined, {});
    $grammar.addRule("bookkeeping", [], "quiet", (() => special('stop')), undefined, {});
    $grammar.addRule("bookkeeping", [], "close", (() => special('stop')), undefined, {});
    $grammar.addRule("bookkeeping", [], "yes", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "yes please", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "yes ,  please", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "yeah", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "ok", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "okay", (() => special('yes')), undefined, {});
    $grammar.addRule("bookkeeping", [], "no", (() => special('no')), undefined, {});
    $grammar.addRule("bookkeeping", [], "no thanks", (() => special('no')), undefined, {});
    $grammar.addRule("bookkeeping", [], "no ,  thanks", (() => special('no')), undefined, {});
    $grammar.addRule("bookkeeping", [], "nope", (() => special('no')), undefined, {});
    $grammar.addRule("bookkeeping", [new $runtime.NonTerminal("constant_Any", "c", undefined)], "${c}", ((c) => new thingtalk_1.Ast.ControlCommand(null, new thingtalk_1.Ast.AnswerControlIntent(null, c))), undefined, {});
    $grammar.declareSymbol("$root");
    $grammar.addRule("$root", [new $runtime.NonTerminal("bookkeeping", undefined, undefined)], "${bookkeeping}", (($0) => { return $0; }), undefined, { identity: (true) });
    $grammar.addRule("$root", [new $runtime.NonTerminal("thingpedia_complete_query", "query", undefined)], $locale._("get ${query}"), ((query) => C.makeProgram($loader, query)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("thingpedia_complete_get_command", "query", undefined)], "${query}", ((query) => C.makeProgram($loader, query)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("thingpedia_complete_action", "action", undefined)], "${action}", ((action) => C.makeProgram($loader, action)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("thingpedia_complete_stream", "stream", undefined)], $locale._("notify me ${stream}"), ((stream) => C.makeProgram($loader, stream)), undefined, {});
}
exports.default = default_1;
;
//# sourceMappingURL=basic.genie.js.map