"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2019-2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const C = __importStar(require("../ast_manip"));
const load_thingpedia_1 = __importDefault(require("../load-thingpedia"));
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    $loader = new load_thingpedia_1.default($runtime, $ttUtils, $grammar, $locale, $options);
    await (await $runtime.import("../common.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await $loader.init();
    await (await $runtime.import("./shared.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./constants.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./timers.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./filters.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./projections.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./aggregation.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./computation.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./who_questions.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./commands.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    await (await $runtime.import("./stream_tables.genie", __dirname))($runtime, $ttUtils, $options, $locale, $grammar, $loader);
    $grammar.declareSymbol("$root");
    $grammar.addRule("$root", [new $runtime.NonTerminal("thingpedia_complete_program", "p", undefined)], "${p}", ((p) => C.makeProgram($loader, p)), undefined, {});
    if (!$options.flags.nostream) {
        if ($options.flags.timer) {
            $grammar.addRule("$root", [new $runtime.NonTerminal("timer_rule", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.2) });
        }
        $grammar.addRule("$root", [new $runtime.NonTerminal("monitor_command", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.2) });
        $grammar.addRule("$root", [new $runtime.NonTerminal("when_command", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.2) });
    }
    $grammar.addRule("$root", [new $runtime.NonTerminal("say_command", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.1) });
    $grammar.addRule("$root", [new $runtime.NonTerminal("complete_action", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("generic_preamble_for_action", undefined, undefined), new $runtime.NonTerminal("complete_action", "stmt", undefined)], $locale._("${generic_preamble_for_action} ${stmt}"), (($0, stmt) => C.makeProgram($loader, stmt)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("generic_preamble_for_action", undefined, undefined), new $runtime.NonTerminal("forward_get_do_command", "stmt", undefined)], $locale._("${generic_preamble_for_action} ${stmt}"), (($0, stmt) => C.makeProgram($loader, stmt)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("backward_get_do_command", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.1) });
    $grammar.addRule("$root", [new $runtime.NonTerminal("search_command", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, {});
    $grammar.addRule("$root", [new $runtime.NonTerminal("complete_question", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.1) });
    $grammar.addRule("$root", [new $runtime.NonTerminal("projection_question", "stmt", undefined)], "${stmt}", ((stmt) => C.makeProgram($loader, stmt)), undefined, { weight: (0.1) });
}
exports.default = default_1;
;
//# sourceMappingURL=thingtalk.genie.js.map