"use strict";
// -*- mode: js; indent-tabs-mode: nil; js-basic-offset: 4 -*-
//
// This file is part of Genie
//
// Copyright 2019-2020 The Board of Trustees of the Leland Stanford Junior University
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Author: Giovanni Campagna <gcampagn@cs.stanford.edu>
Object.defineProperty(exports, "__esModule", { value: true });
const thingtalk_1 = require("thingtalk");
async function default_1($runtime, $ttUtils, $options, $locale, $grammar, $loader) {
    const TIME_MORNING = new thingtalk_1.Ast.Value.Time(new thingtalk_1.Ast.Time.Relative("morning"));
    const TIME_NOON = new thingtalk_1.Ast.Value.Time(new thingtalk_1.Ast.Time.Absolute(12, 0, 0));
    const TIME_EVENING = new thingtalk_1.Ast.Value.Time(new thingtalk_1.Ast.Time.Relative("evening"));
    $grammar.declareSymbol("optional_comma");
    $grammar.addRule("optional_comma", [], ",", (() => ','), undefined, {});
    $grammar.addRule("optional_comma", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("per_day");
    $grammar.addRule("per_day", [], "each day", (() => 'each day'), undefined, {});
    $grammar.addRule("per_day", [], "every day", (() => 'every day'), undefined, {});
    $grammar.addRule("per_day", [], "daily", (() => 'daily'), undefined, {});
    $grammar.addRule("per_day", [], "a day", (() => 'a day'), undefined, {});
    $grammar.addRule("per_day", [], "per day", (() => 'per day'), undefined, {});
    $grammar.declareSymbol("optional_per_day");
    $grammar.addRule("optional_per_day", [], "each day", (() => 'each day'), undefined, {});
    $grammar.addRule("optional_per_day", [], "every day", (() => 'every day'), undefined, {});
    $grammar.addRule("optional_per_day", [], "daily", (() => 'daily'), undefined, {});
    $grammar.addRule("optional_per_day", [], "a day", (() => 'a day'), undefined, {});
    $grammar.addRule("optional_per_day", [], "per day", (() => 'per day'), undefined, {});
    $grammar.addRule("optional_per_day", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("once_per_day");
    $grammar.addRule("once_per_day", [], "each day", (() => 'each day'), undefined, {});
    $grammar.addRule("once_per_day", [], "every day", (() => 'every day'), undefined, {});
    $grammar.addRule("once_per_day", [], "daily", (() => 'daily'), undefined, {});
    $grammar.addRule("once_per_day", [], "a day", (() => 'a day'), undefined, {});
    $grammar.addRule("once_per_day", [], "per day", (() => 'per day'), undefined, {});
    $grammar.addRule("once_per_day", [], "once a day", (() => 'once a day'), undefined, {});
    $grammar.addRule("once_per_day", [], "once per day", (() => 'once per day'), undefined, {});
    $grammar.addRule("once_per_day", [], "once daily", (() => 'once daily'), undefined, {});
    $grammar.addRule("once_per_day", [], "one time a day", (() => 'one time a day'), undefined, {});
    $grammar.addRule("once_per_day", [], "one time per day", (() => 'one time per day'), undefined, {});
    $grammar.addRule("once_per_day", [], "one time daily", (() => 'one time daily'), undefined, {});
    $grammar.declareSymbol("twice_per_day");
    $grammar.addRule("twice_per_day", [], "twice a day", (() => 'twice a day'), undefined, {});
    $grammar.addRule("twice_per_day", [], "twice per day", (() => 'twice per day'), undefined, {});
    $grammar.addRule("twice_per_day", [], "twice daily", (() => 'twice daily'), undefined, {});
    $grammar.addRule("twice_per_day", [], "two times a day", (() => 'two times a day'), undefined, {});
    $grammar.addRule("twice_per_day", [], "two times per day", (() => 'two times per day'), undefined, {});
    $grammar.addRule("twice_per_day", [], "two times daily", (() => 'two times daily'), undefined, {});
    $grammar.declareSymbol("thrice_per_day");
    $grammar.addRule("thrice_per_day", [], "thrice a day", (() => 'thrice a day'), undefined, {});
    $grammar.addRule("thrice_per_day", [], "thrice per day", (() => 'thrice per day'), undefined, {});
    $grammar.addRule("thrice_per_day", [], "thrice daily", (() => 'thrice daily'), undefined, {});
    $grammar.addRule("thrice_per_day", [], "three times a day", (() => 'three times a day'), undefined, {});
    $grammar.addRule("thrice_per_day", [], "three times per day", (() => 'three times per day'), undefined, {});
    $grammar.addRule("thrice_per_day", [], "three times daily", (() => 'three times daily'), undefined, {});
    $grammar.declareSymbol("optional_once");
    $grammar.addRule("optional_once", [], "once", (() => 'once'), undefined, {});
    $grammar.addRule("optional_once", [], "one time", (() => 'one time'), undefined, {});
    $grammar.addRule("optional_once", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("optional_twice");
    $grammar.addRule("optional_twice", [], "twice", (() => 'twice'), undefined, {});
    $grammar.addRule("optional_twice", [], "two times", (() => 'two times'), undefined, {});
    $grammar.addRule("optional_twice", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("each");
    $grammar.addRule("each", [], "each", (() => 'each'), undefined, {});
    $grammar.addRule("each", [], "every", (() => 'every'), undefined, {});
    $grammar.addRule("each", [], "per", (() => 'per'), undefined, {});
    $grammar.addRule("each", [], "a", (() => 'a'), undefined, {});
    $grammar.declareSymbol("and");
    $grammar.addRule("and", [], "and", (() => 'and'), undefined, {});
    $grammar.addRule("and", [], "and also", (() => 'and also'), undefined, {});
    $grammar.addRule("and", [], "plus", (() => 'plus'), undefined, {});
    $grammar.addRule("and", [], "in addition to", (() => 'in addition to'), undefined, {});
    $grammar.addRule("and", [], ",", (() => ','), undefined, {});
    $grammar.declareSymbol("optional_first");
    $grammar.addRule("optional_first", [], "one", (() => 'one'), undefined, {});
    $grammar.addRule("optional_first", [], "once", (() => 'once'), undefined, {});
    $grammar.addRule("optional_first", [], "one time", (() => 'one time'), undefined, {});
    $grammar.addRule("optional_first", [], "first", (() => 'first'), undefined, {});
    $grammar.addRule("optional_first", [], "the first", (() => 'the first'), undefined, {});
    $grammar.addRule("optional_first", [], "the first one", (() => 'the first one'), undefined, {});
    $grammar.addRule("optional_first", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("optional_second");
    $grammar.addRule("optional_second", [], "one", (() => 'one'), undefined, {});
    $grammar.addRule("optional_second", [], "once", (() => 'once'), undefined, {});
    $grammar.addRule("optional_second", [], "one time", (() => 'one time'), undefined, {});
    $grammar.addRule("optional_second", [], "one more", (() => 'one more'), undefined, {});
    $grammar.addRule("optional_second", [], "once more", (() => 'once more'), undefined, {});
    $grammar.addRule("optional_second", [], "one more time", (() => 'one more time'), undefined, {});
    $grammar.addRule("optional_second", [], "again", (() => 'again'), undefined, {});
    $grammar.addRule("optional_second", [], "once again", (() => 'once again'), undefined, {});
    $grammar.addRule("optional_second", [], "another", (() => 'another'), undefined, {});
    $grammar.addRule("optional_second", [], "another time", (() => 'another time'), undefined, {});
    $grammar.addRule("optional_second", [], "another one", (() => 'another one'), undefined, {});
    $grammar.addRule("optional_second", [], "second", (() => 'second'), undefined, {});
    $grammar.addRule("optional_second", [], "a second", (() => 'a second'), undefined, {});
    $grammar.addRule("optional_second", [], "a second one", (() => 'a second one'), undefined, {});
    $grammar.addRule("optional_second", [], "the second", (() => 'the second'), undefined, {});
    $grammar.addRule("optional_second", [], "the second one", (() => 'the second one'), undefined, {});
    $grammar.addRule("optional_second", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("optional_emphasis");
    $grammar.addRule("optional_emphasis", [], "just", (() => 'just'), undefined, {});
    $grammar.addRule("optional_emphasis", [], "right", (() => 'right'), undefined, {});
    $grammar.addRule("optional_emphasis", [], "", (() => ''), undefined, {});
    $grammar.declareSymbol("at_noon");
    $grammar.addRule("at_noon", [], "at noon", (() => 'at noon'), undefined, {});
    $grammar.addRule("at_noon", [], "in the middle of the day", (() => 'in the middle of the day'), undefined, {});
    $grammar.addRule("at_noon", [], "at lunch", (() => 'at lunch'), undefined, {});
    $grammar.declareSymbol("at_morning");
    $grammar.addRule("at_morning", [], "when i get up", (() => 'when i get up'), undefined, {});
    $grammar.addRule("at_morning", [], "when i wake up", (() => 'when i wake up'), undefined, {});
    $grammar.addRule("at_morning", [], "after getting up", (() => 'after getting up'), undefined, {});
    $grammar.addRule("at_morning", [], "after i get up", (() => 'after i get up'), undefined, {});
    $grammar.addRule("at_morning", [], "after waking up", (() => 'after waking up'), undefined, {});
    $grammar.addRule("at_morning", [], "after i wake up", (() => 'after i wake up'), undefined, {});
    $grammar.addRule("at_morning", [], "during the morning", (() => 'during the morning'), undefined, {});
    $grammar.addRule("at_morning", [], "each morning", (() => 'each morning'), undefined, {});
    $grammar.addRule("at_morning", [], "every morning", (() => 'every morning'), undefined, {});
    $grammar.addRule("at_morning", [], "in the morning", (() => 'in the morning'), undefined, {});
    $grammar.addRule("at_morning", [], "at breakfast", (() => 'at breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "with breakfast", (() => 'with breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "during breakfast", (() => 'during breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "before breakfast", (() => 'before breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "before eating breakfast", (() => 'before eating breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "before i eat breakfast", (() => 'before i eat breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "after breakfast", (() => 'after breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "after eating breakfast", (() => 'after eating breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "after i eat breakfast", (() => 'after i eat breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "when i eat breakfast", (() => 'when i eat breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "while i eat breakfast", (() => 'while i eat breakfast'), undefined, {});
    $grammar.addRule("at_morning", [], "before school", (() => 'before school'), undefined, {});
    $grammar.addRule("at_morning", [], "before going to school", (() => 'before going to school'), undefined, {});
    $grammar.addRule("at_morning", [], "before i go to school", (() => 'before i go to school'), undefined, {});
    $grammar.addRule("at_morning", [], "before leaving for school", (() => 'before leaving for school'), undefined, {});
    $grammar.addRule("at_morning", [], "before i leave for school", (() => 'before i leave for school'), undefined, {});
    $grammar.addRule("at_morning", [], "before heading to school", (() => 'before heading to school'), undefined, {});
    $grammar.addRule("at_morning", [], "before i head to school", (() => 'before i head to school'), undefined, {});
    $grammar.addRule("at_morning", [], "when i go to school", (() => 'when i go to school'), undefined, {});
    $grammar.addRule("at_morning", [], "when i leave for school", (() => 'when i leave for school'), undefined, {});
    $grammar.addRule("at_morning", [], "when i head to school", (() => 'when i head to school'), undefined, {});
    $grammar.addRule("at_morning", [], "before work", (() => 'before work'), undefined, {});
    $grammar.addRule("at_morning", [], "before going to work", (() => 'before going to work'), undefined, {});
    $grammar.addRule("at_morning", [], "before i go to work", (() => 'before i go to work'), undefined, {});
    $grammar.addRule("at_morning", [], "before leaving for work", (() => 'before leaving for work'), undefined, {});
    $grammar.addRule("at_morning", [], "before i leave for work", (() => 'before i leave for work'), undefined, {});
    $grammar.addRule("at_morning", [], "before heading to work", (() => 'before heading to work'), undefined, {});
    $grammar.addRule("at_morning", [], "before i head to work", (() => 'before i head to work'), undefined, {});
    $grammar.addRule("at_morning", [], "when i go to work", (() => 'when i go to work'), undefined, {});
    $grammar.addRule("at_morning", [], "when i leave for work", (() => 'when i leave for work'), undefined, {});
    $grammar.addRule("at_morning", [], "when i head to work", (() => 'when i head to work'), undefined, {});
    $grammar.declareSymbol("at_evening");
    $grammar.addRule("at_evening", [], "during the evening", (() => 'during the evening'), undefined, {});
    $grammar.addRule("at_evening", [], "each evening", (() => 'each evening'), undefined, {});
    $grammar.addRule("at_evening", [], "every evening", (() => 'every evening'), undefined, {});
    $grammar.addRule("at_evening", [], "in the evening", (() => 'in the evening'), undefined, {});
    $grammar.addRule("at_evening", [], "during the night", (() => 'during the night'), undefined, {});
    $grammar.addRule("at_evening", [], "each night", (() => 'each night'), undefined, {});
    $grammar.addRule("at_evening", [], "every night", (() => 'every night'), undefined, {});
    $grammar.addRule("at_evening", [], "in the night", (() => 'in the night'), undefined, {});
    $grammar.addRule("at_evening", [], "at night", (() => 'at night'), undefined, {});
    $grammar.addRule("at_evening", [], "at dinner", (() => 'at dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "with dinner", (() => 'with dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "during dinner", (() => 'during dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "before dinner", (() => 'before dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "before eating dinner", (() => 'before eating dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "before i eat dinner", (() => 'before i eat dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "after dinner", (() => 'after dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "after eating dinner", (() => 'after eating dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "after i eat dinner", (() => 'after i eat dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "when i eat dinner", (() => 'when i eat dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "while i eat dinner", (() => 'while i eat dinner'), undefined, {});
    $grammar.addRule("at_evening", [], "after school", (() => 'after school'), undefined, {});
    $grammar.addRule("at_evening", [], "after getting back from school", (() => 'after getting back from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after returning from school", (() => 'after returning from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after coming home from school", (() => 'after coming home from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after i get back from school", (() => 'after i get back from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after i return from school", (() => 'after i return from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after i come home from school", (() => 'after i come home from school'), undefined, {});
    $grammar.addRule("at_evening", [], "when i get back from school", (() => 'when i get back from school'), undefined, {});
    $grammar.addRule("at_evening", [], "when i return from school", (() => 'when i return from school'), undefined, {});
    $grammar.addRule("at_evening", [], "when i come home from school", (() => 'when i come home from school'), undefined, {});
    $grammar.addRule("at_evening", [], "after work", (() => 'after work'), undefined, {});
    $grammar.addRule("at_evening", [], "after getting back from work", (() => 'after getting back from work'), undefined, {});
    $grammar.addRule("at_evening", [], "after returning from work", (() => 'after returning from work'), undefined, {});
    $grammar.addRule("at_evening", [], "after coming home from work", (() => 'after coming home from work'), undefined, {});
    $grammar.addRule("at_evening", [], "after i get back from work", (() => 'after i get back from work'), undefined, {});
    $grammar.addRule("at_evening", [], "after i return from work", (() => 'after i return from work'), undefined, {});
    $grammar.addRule("at_evening", [], "after i come home from work", (() => 'after i come home from work'), undefined, {});
    $grammar.addRule("at_evening", [], "when i get back from work", (() => 'when i get back from work'), undefined, {});
    $grammar.addRule("at_evening", [], "when i return from work", (() => 'when i return from work'), undefined, {});
    $grammar.addRule("at_evening", [], "when i come home from work", (() => 'when i come home from work'), undefined, {});
    $grammar.addRule("at_evening", [], "before bed", (() => 'before bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before going to bed", (() => 'before going to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before i go to bed", (() => 'before i go to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before leaving for bed", (() => 'before leaving for bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before i leave for bed", (() => 'before i leave for bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before heading to bed", (() => 'before heading to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "before i head to bed", (() => 'before i head to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "when i go to bed", (() => 'when i go to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "when i leave for bed", (() => 'when i leave for bed'), undefined, {});
    $grammar.addRule("at_evening", [], "when i head to bed", (() => 'when i head to bed'), undefined, {});
    $grammar.addRule("at_evening", [], "at bedtime", (() => 'at bedtime'), undefined, {});
    $grammar.addRule("at_evening", [], "before bedtime", (() => 'before bedtime'), undefined, {});
    $grammar.addRule("at_evening", [], "before i go to sleep", (() => 'before i go to sleep'), undefined, {});
    $grammar.addRule("at_evening", [], "before going to sleep", (() => 'before going to sleep'), undefined, {});
    $grammar.addRule("at_evening", [], "before sleeping", (() => 'before sleeping'), undefined, {});
    $grammar.addRule("at_evening", [], "before i sleep", (() => 'before i sleep'), undefined, {});
    $grammar.addRule("at_evening", [], "before i fall asleep", (() => 'before i fall asleep'), undefined, {});
    $grammar.addRule("at_evening", [], "before falling asleep", (() => 'before falling asleep'), undefined, {});
    $grammar.declareSymbol("at_evening_second");
    $grammar.addRule("at_evening_second", [], "evening", (() => 'evening'), undefined, {});
    $grammar.addRule("at_evening_second", [], "work", (() => 'work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "school", (() => 'school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "dinner", (() => 'dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "night", (() => 'night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "bed", (() => 'bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "during the evening", (() => 'during the evening'), undefined, {});
    $grammar.addRule("at_evening_second", [], "each evening", (() => 'each evening'), undefined, {});
    $grammar.addRule("at_evening_second", [], "every evening", (() => 'every evening'), undefined, {});
    $grammar.addRule("at_evening_second", [], "in the evening", (() => 'in the evening'), undefined, {});
    $grammar.addRule("at_evening_second", [], "during the night", (() => 'during the night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "each night", (() => 'each night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "every night", (() => 'every night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "in the night", (() => 'in the night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "at night", (() => 'at night'), undefined, {});
    $grammar.addRule("at_evening_second", [], "at dinner", (() => 'at dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "with dinner", (() => 'with dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "during dinner", (() => 'during dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before dinner", (() => 'before dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before eating dinner", (() => 'before eating dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i eat dinner", (() => 'before i eat dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after dinner", (() => 'after dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after eating dinner", (() => 'after eating dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i eat dinner", (() => 'after i eat dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i eat dinner", (() => 'when i eat dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "while i eat dinner", (() => 'while i eat dinner'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after school", (() => 'after school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after getting back from school", (() => 'after getting back from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after returning from school", (() => 'after returning from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after coming home from school", (() => 'after coming home from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i get back from school", (() => 'after i get back from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i return from school", (() => 'after i return from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i come home from school", (() => 'after i come home from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i get back from school", (() => 'when i get back from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i return from school", (() => 'when i return from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i come home from school", (() => 'when i come home from school'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after work", (() => 'after work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after getting back from work", (() => 'after getting back from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after returning from work", (() => 'after returning from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after coming home from work", (() => 'after coming home from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i get back from work", (() => 'after i get back from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i return from work", (() => 'after i return from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "after i come home from work", (() => 'after i come home from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i get back from work", (() => 'when i get back from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i return from work", (() => 'when i return from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i come home from work", (() => 'when i come home from work'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before bed", (() => 'before bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before going to bed", (() => 'before going to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i go to bed", (() => 'before i go to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before leaving for bed", (() => 'before leaving for bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i leave for bed", (() => 'before i leave for bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before heading to bed", (() => 'before heading to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i head to bed", (() => 'before i head to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i go to bed", (() => 'when i go to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i leave for bed", (() => 'when i leave for bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "when i head to bed", (() => 'when i head to bed'), undefined, {});
    $grammar.addRule("at_evening_second", [], "at bedtime", (() => 'at bedtime'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before bedtime", (() => 'before bedtime'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i go to sleep", (() => 'before i go to sleep'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before going to sleep", (() => 'before going to sleep'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before sleeping", (() => 'before sleeping'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i sleep", (() => 'before i sleep'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before i fall asleep", (() => 'before i fall asleep'), undefined, {});
    $grammar.addRule("at_evening_second", [], "before falling asleep", (() => 'before falling asleep'), undefined, {});
    $grammar.declareSymbol("when_brushing_teeth");
    $grammar.addRule("when_brushing_teeth", [], "when i brush my teeth", (() => 'when i brush my teeth'), undefined, {});
    $grammar.addRule("when_brushing_teeth", [], "when brushing my teeth", (() => 'when brushing my teeth'), undefined, {});
    $grammar.addRule("when_brushing_teeth", [], "before brushing my teeth", (() => 'before brushing my teeth'), undefined, {});
    $grammar.addRule("when_brushing_teeth", [], "before i brush my teeth", (() => 'before i brush my teeth'), undefined, {});
    $grammar.addRule("when_brushing_teeth", [], "after brushing my teeth", (() => 'after brushing my teeth'), undefined, {});
    $grammar.addRule("when_brushing_teeth", [], "after i brush my teeth", (() => 'after i brush my teeth'), undefined, {});
    $grammar.declareSymbol("on");
    $grammar.addRule("on", [], "on", (() => 'on'), undefined, {});
    $grammar.addRule("on", [], "when it 's", (() => 'when it \'s'), undefined, {});
    $grammar.addRule("on", [], "when it is", (() => 'when it is'), undefined, {});
    $grammar.declareSymbol("timer");
    if ($options.flags.extended_timers) {
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("optional_emphasis", undefined, undefined), new $runtime.NonTerminal("at_noon", undefined, undefined)], $locale._("${optional_once} ${optional_emphasis} ${at_noon}"), (($0, $1, $2) => new thingtalk_1.Ast.Stream.AtTimer(null, [TIME_NOON], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("optional_emphasis", undefined, undefined), new $runtime.NonTerminal("at_morning", undefined, undefined)], $locale._("${optional_once} ${optional_emphasis} ${at_morning}"), (($0, $1, $2) => new thingtalk_1.Ast.Stream.AtTimer(null, [TIME_MORNING], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("optional_emphasis", undefined, undefined), new $runtime.NonTerminal("at_evening", undefined, undefined)], $locale._("${optional_once} ${optional_emphasis} ${at_evening}"), (($0, $1, $2) => new thingtalk_1.Ast.Stream.AtTimer(null, [TIME_EVENING], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_twice", undefined, undefined), new $runtime.NonTerminal("optional_per_day", undefined, undefined), new $runtime.NonTerminal("optional_comma", undefined, undefined), new $runtime.NonTerminal("optional_first", undefined, undefined), new $runtime.NonTerminal("optional_emphasis", undefined, undefined), new $runtime.NonTerminal("at_morning", undefined, undefined), new $runtime.NonTerminal("and", undefined, undefined), new $runtime.NonTerminal("optional_second", undefined, undefined), new $runtime.NonTerminal("optional_emphasis", undefined, undefined), new $runtime.NonTerminal("at_evening_second", undefined, undefined)], $locale._("${optional_twice} ${optional_per_day} ${optional_comma} ${optional_first} ${optional_emphasis} ${at_morning} ${and} ${optional_second} ${optional_emphasis} ${at_evening_second}"), (($0, $1, $2, $3, $4, $5, $6, $7, $8, $9) => new thingtalk_1.Ast.Stream.AtTimer(null, [TIME_MORNING, TIME_EVENING], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("when_brushing_teeth", undefined, undefined)], "${when_brushing_teeth}", (($0) => new thingtalk_1.Ast.Stream.AtTimer(null, [TIME_MORNING, TIME_EVENING], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
    }
    $grammar.addRule("timer", [new $runtime.NonTerminal("once_per_day", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time", undefined)], $locale._("${once_per_day} at ${time}"), (($0, time) => new thingtalk_1.Ast.Stream.AtTimer(null, [time], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
    $grammar.addRule("timer", [new $runtime.NonTerminal("twice_per_day", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time1", undefined), new $runtime.NonTerminal("and", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time2", undefined)], $locale._("${twice_per_day} at ${time1} ${and} ${time2}"), (($0, time1, $1, time2) => new thingtalk_1.Ast.Stream.AtTimer(null, [time1, time2], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
    $grammar.addRule("timer", [new $runtime.NonTerminal("thrice_per_day", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time1", undefined), new $runtime.NonTerminal("and", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time2", undefined), new $runtime.NonTerminal("and", undefined, undefined), new $runtime.NonTerminal("constant_Time", "time3", undefined)], $locale._("${thrice_per_day} at ${time1} ${and} ${time2} ${and} ${time3}"), (($0, time1, $1, time2, $2, time3) => new thingtalk_1.Ast.Stream.AtTimer(null, [time1, time2, time3], null, $loader.standardSchemas.attimer).toExpression()), undefined, {});
    if (!$options.flags.turking) {
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("each", undefined, undefined), new $runtime.NonTerminal("constant_Measure_ms", "interval", undefined)], $locale._("${optional_once} ${each} ${interval}"), (($0, $1, interval) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), interval, null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("once_per_day", undefined, undefined)], "${once_per_day}", (($0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'day'), null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${optional_once} ${each} year"), (($0, $1) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'year'), null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${optional_once} ${each} month"), (($0, $1) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'mon'), null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${optional_once} ${each} week"), (($0, $1) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'week'), null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("optional_once", undefined, undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${optional_once} ${each} hour"), (($0, $1) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'h'), null, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} minute"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'min'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} hour"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'h'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} day"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'day'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} week"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'week'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} month"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'mon'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined)], $locale._("${freq} times ${each} year"), ((freq, $0) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), new thingtalk_1.Ast.Value.Measure(1, 'year'), freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
        $grammar.addRule("timer", [new $runtime.NonTerminal("constant_Number", "freq", undefined), new $runtime.NonTerminal("each", undefined, undefined), new $runtime.NonTerminal("constant_Measure_ms", "interval", undefined)], $locale._("${freq} times ${each} ${interval}"), ((freq, $0, interval) => new thingtalk_1.Ast.Stream.Timer(null, new thingtalk_1.Ast.Value.Date(null), interval, freq, $loader.standardSchemas.timer).toExpression()), undefined, {});
    }
}
exports.default = default_1;
;
//# sourceMappingURL=timers.genie.js.map